import React, { useCallback, useEffect, useRef, useState } from 'react';
import { useManageSucosContext } from '../hooks/useManageSucosContext';
import { Alert, useDataGrid } from '@/components';
import { useCallApi } from '@/hooks';
import { getAuth } from '@/auth';
import { apiConfig } from '@/config/api.config';
import { toast } from 'sonner';
import {
  Dialog,
  DialogBody,
  DialogContent,
  DialogDescription,
  DialogHeader,
  DialogTitle
} from '@/components/ui/dialog';
import { Input } from '@/components/ui/input';
import { Button } from '@/components/ui/button';
import { Popover, PopoverContent, PopoverTrigger } from '@/components/ui/popover';
import {
  Command,
  CommandEmpty,
  CommandGroup,
  CommandInput,
  CommandItem,
  CommandList
} from '@/components/ui/command';
import { doSaveLogActivity } from '@/actions/GlobalActions';

interface PostoAdmsProps {
  PostoAdms_id: number;
  PostoAdms_name: string;
}
const API_URL = apiConfig.service_master_data;

const AddDialog = () => {
  const parentRef = useRef<any | null>(null);
  const { showAddDialog, handleAddDialog, selectedSucos } = useManageSucosContext();
  const { reload } = useDataGrid();
  const { PostData, GetData } = useCallApi();
  const parsedUser = getAuth()?.user;
  const [posto_adms, setPostoadms] = useState<PostoAdmsProps[]>([]);
  const [open, setOpen] = useState(false);
  const [alert, setAlert] = useState({
    show: false,
    message: ''
  });
  const initialState = {
    name: '',
    postoId: 0,
    created_by: '',
    created_at: ''
  };

  const [formField, setFormField] = useState(initialState);
  const created_time = new Date();
  const formattedTime = created_time.toISOString().slice(0, 19).replace('T', ' ');

  const resetForm = () => {
    setFormField(initialState);
    setAlert({ show: false, message: '' });
  };

  const doCreateSucos = useCallback(
    async (e: React.FormEvent<HTMLFormElement>) => {
      e.preventDefault();
      const response = await PostData(`${API_URL}/sucos/create`, formField);

      if (response?.status) {
        resetForm();
        handleAddDialog(false);
        reload();
        toast.success('Sucos created successfully!');
        const createActivity = {
          module: 'Manage Sucos',
          description: `Create Sucos => ${formField.name}`,
          action: 'C'
        };

        doSaveLogActivity(createActivity);
      } else {
        toast.error('Failed to create Sucos Please try again.');
        setAlert({ show: true, message: 'Failed to create Sucos Please try again.' });
      }
    },
    [formField]
  );

  const handleSubmit = (e: React.FormEvent<HTMLFormElement>) => {
    e.preventDefault();

    if (formField.name.trim() === '' || formField.postoId === 0) {
      setAlert({ show: true, message: 'Please fill in all required fields.' });
      return;
    }

    doCreateSucos(e);
    console.log(formField);
    setAlert({ show: false, message: '' });
  };

  useEffect(() => {
    if (showAddDialog) {
      setFormField({
        ...formField,
        created_by: parsedUser?.username,
        created_at: formattedTime
      });
    }
  }, [formattedTime]);

  useEffect(() => {
    if (showAddDialog === false) {
      resetForm();
    }
  }, [showAddDialog]);

  useEffect(() => {
    const fetchPostoAdms = async (sorting: any) => {
      try {
        sorting = sorting.length == 0 ? [{ id: 'name', desc: false }] : sorting;
        const response = await GetData(`${API_URL}/postoadms/list`, {
          limit: 100,
          page: 1,
          with_deleted: false,
          order_field: sorting[0].id,
          order_direction: sorting[0].desc == false ? 'ASC' : 'DESC'
        });
        // console.log('ini data posto :', response?.data);
        setPostoadms(response?.data.list || []);
      } catch (error) {
        console.log('Error fetching Postu Administrativo', error);
        setAlert({ show: true, message: 'Failed to get Posto Administrativo. Please try again.' });
      }
    };

    fetchPostoAdms([{ id: 'name', desc: false }]);
  }, []);

  return (
    <Dialog open={showAddDialog} onOpenChange={(open) => handleAddDialog(open)}>
      <DialogContent className="container-fixed max-w-[768px] flex flex-col p-5">
        <DialogHeader>
          <DialogTitle>Sucos - Create</DialogTitle>
          <DialogDescription></DialogDescription>
        </DialogHeader>
        <DialogBody ref={parentRef}>
          <div className="flex flex-col">
            {alert.show && (
              <Alert variant="danger">
                <h3>{alert.message}</h3>
              </Alert>
            )}

            <form onSubmit={handleSubmit}>
              <div className="card-body grid gap-5">
                <div className="w-full">
                  <div className="flex items-baseline flex-wrap lg:flex-nowrap gap-2.5">
                    <label className="form-label flex items-center gap-1 max-w-56">
                      Sucos Name<span className="text-red-500">*</span>
                    </label>
                    <Input
                      className="input"
                      type="text"
                      value={formField.name}
                      onChange={(e) => setFormField({ ...formField, name: e.target.value })}
                    />
                  </div>
                </div>

                <div className="w-full">
                  <div className="flex items-baseline flex-wrap lg:flex-nowrap gap-2.5">
                    <label className="form-label flex items-center gap-1 max-w-56">
                      Postu Administrativo ID<span className="text-red-500">*</span>
                    </label>
                    <Popover open={open} onOpenChange={setOpen}>
                      <PopoverTrigger asChild>
                        <button type="button" className="input col-span-5 text-left">
                          {posto_adms.find((posto) => posto.PostoAdms_id === formField.postoId)
                            ?.PostoAdms_name || 'Select Postu Administrativo'}
                        </button>
                      </PopoverTrigger>
                      <PopoverContent
                        className="w-[400px] p-0"
                        onWheel={(e) => e.stopPropagation()}
                      >
                        <Command>
                          <CommandInput placeholder="Search Postu Administrativo..." />
                          <CommandList>
                            <CommandEmpty>No Postu Administrativo Found.</CommandEmpty>
                            <CommandGroup>
                              {posto_adms.map((posto) => (
                                <CommandItem
                                  key={posto.PostoAdms_id}
                                  value={posto.PostoAdms_name}
                                  onSelect={() => {
                                    setFormField({
                                      ...formField,
                                      postoId: posto.PostoAdms_id
                                    });
                                    setOpen(false);
                                  }}
                                >
                                  {posto.PostoAdms_name}
                                </CommandItem>
                              ))}
                            </CommandGroup>
                          </CommandList>
                        </Command>
                      </PopoverContent>
                    </Popover>
                    {/* <Input
                      className="input"
                      type="number"
                      min={0}
                      value={formField.posto_adm_id === 0 ? '' : formField.posto_adm_id}
                      onChange={(e) => {
                        const value = parseInt(e.target.value, 10);
                        setFormField({ ...formField, posto_adm_id: isNaN(value) ? 0 : value });
                      }}
                    /> */}
                  </div>
                </div>

                <div className="flex justify-end gap-5">
                  <Button type="button" variant="outline" onClick={resetForm}>
                    Reset
                  </Button>
                  <Button variant="default">Save Changes</Button>
                </div>
              </div>
            </form>
          </div>
        </DialogBody>
      </DialogContent>
    </Dialog>
  );
};

export default AddDialog;
